require_relative 'expression'

module Qdsl
  class Boolean < Expression
    def initialize(operator, exprs)
      @operator = operator
      @exprs = exprs
    end

    def render_sql(context, ids)
      expr_results = @exprs.collect { |x| render_operand(context, ids, x) }
      parameters = expr_results.inject({}) { |acc, x| acc.merge(x.parameters) }
      SimpleRenderResult.new(expr_results.collect { |x| "(#{x.sql})" }.join(" #{@operator} "), parameters)
    end
  end
end

