module Qdsl
  class ColumnProxy
    def initialize(source)
      @source = source
      source.column_names.each do |column|
        (class << self; self; end).class_eval do
          define_method column do
            Column.new(column, nil, source)
          end
        end
      end
    end

    def [](name)
      raise "Unknown column \"#{name}\"" unless @source.column_names.include?(name.to_s)
      Column.new(name.to_s, nil, @source)
    end

    def _call(function_name, *parameters)
      Call.new(@source, function_name, parameters)
    end

    def _formatcall(format, *parameters)
      FormatCall.new(@source, format, parameters)
    end
  end
end

