module Qdsl
  class Expression
    def and(expr)
      And.new([self, expr])
    end

    def or(expr)
      Or.new([self, expr])
    end

    protected

    def render_operand(context, ids, operand)
      if operand.is_a?(String)
        parameter_id = context.create_parameter_id
        SimpleRenderResult.new(":#{parameter_id}", {parameter_id => operand})
      elsif operand.is_a?(TrueClass)
        SimpleRenderResult.new('TRUE', {})
      elsif operand.is_a?(FalseClass)
        SimpleRenderResult.new('FALSE', {})
      elsif operand.is_a?(Expression)
        operand.render_sql(context, ids)
      else
        operand.render_sql(context, ids[operand.source])
      end
    end
  end
end

