module Qdsl
  class SelectQuery
    def initialize(select, column_set)
      @select = select
      @column_set = column_set
    end

    def render(context, depth, id)
      indent = '  ' * depth

      columns = @column_set.capture(@select.source, [])

      select_result = @select.render(context, depth)

      fragments = []
      fragments << "(\n"
      fragments << select_result.sql
      fragments << ") AS #{id}\n"

      sql = fragments.join
      RenderResult.new(
        id,
        sql,
        columns.collect(&:name),
        {}
      )
    end
  end
end

